//+------------------------------------------------------------------+
//|                                               BBands Scalper.mq4 |
//+------------------------------------------------------------------+
// bollinger band[20]
// envelope[14]
// time frame m15

// when price [up]exceeds both upper bb and upper envelope we short.
// when price [down]exceeds both lower bb and lower envelope we long.

// stop loss 25 - 35
// take profit 8 - 12 

// pairs: EURCHF ,EURGBP, USDJPY

#property copyright "Copyright  2011, Maximo"
#property link      "http://www.worldwide-invest.org"

string        EA_name           = "BBands Scalper";
string        EA_vers           = " v1.0";
extern bool   AllowTrading      = True,
              AlertsOn          = False,
              ArrowsOn          = True,
              EmailOn           = False;
extern double Lots              = 0.01;
extern int    StopLoss          = 220; //25
extern int    TakeProfit        = 8;   //8
extern int    BBands_period     = 20;
extern double BolDeviation      = 2.0;
extern int    Envelope_period   = 14;
extern double EnvDeviation      = 0.10;
extern color  ArrowUP           = Aqua;
extern color  ArrowDOWN         = Magenta;
extern int    MagicNumber       = 12345;

double        PipValue          = 0.0001; // 4 & 5 digit currency
double        BandHi,
              BandLo,
              EnvHi,
              EnvLo;
double        ordertakeprofit,
              orderstoploss,
              lastopenprice,
              openpipsLong,
              openpipsShort;
string        msg;
int           orders;
int           type;
extern int    MaxOrders = 5;
extern int    BasketPips= 12;
extern int    step_1    = 15;
extern double multi_1   = 1.0;
extern int    step_2    = 25;
extern double multi_2   = 1.0;
extern int    step_3    = 40;
extern double multi_3   = 2.0;
extern int    step_4    = 80;
extern double multi_4   = 4.0;

int init()
{
   if (Digits < 4) PipValue = 0.01; // 2 & 3 digit currency JPY
   Display_stats();
   return(0);
}

int deinit() { Comment(""); return(0); }

int start()
{
   Count_Orders();

   if (Signal() == 2 && orders < 1) Trade_SELL(Lots);
   if (Signal() == 1 && orders < 1) Trade_BUY(Lots);

   if (MaxOrders>1) Multi_Orders();

   Display_stats();
   return(0);
}

int Signal()
{
   double BandHi=iBands(NULL, 0, BBands_period, BolDeviation, 0, PRICE_CLOSE, 1, 0);
   double BandLo=iBands(NULL, 0, BBands_period, BolDeviation, 0, PRICE_CLOSE, 2, 0);
   double EnvHi=iEnvelopes(NULL, 0, Envelope_period, MODE_SMA, 0, PRICE_CLOSE, EnvDeviation, 1, 0); 
   double EnvLo=iEnvelopes(NULL, 0, Envelope_period, MODE_SMA, 0, PRICE_CLOSE, EnvDeviation, 2, 0);
   if (Bid > BandHi && Bid > EnvHi) return (2);
   if (Ask < BandLo && Ask < EnvLo) return (1);
   return (0);
}

void Trade_BUY(double lotsize)
{   
   if (AllowTrading)
   {
      if (!Trade_Check()) return;
      int ticket = OrderSend(Symbol(), OP_BUY, lotsize, Ask, 3, 0, 0, EA_name + EA_vers, MagicNumber, 0, Blue);
      if (ticket < 0) { Print("Error opening Order " + GetLastError()); Sleep(30000); }
      if (OrderSelect(ticket, SELECT_BY_TICKET) != False)
      {
         double SL, TP;         
         if (orders < 1) { if (StopLoss > 0 ) SL = OrderOpenPrice() - StopLoss * PipValue; }
         else SL = orderstoploss;
         if (orders < 1) { if (TakeProfit > 0) TP = OrderOpenPrice() + TakeProfit * PipValue; }
         else TP = ordertakeprofit;
         //Print("orderstoploss=",orderstoploss,"  ordertakeprofit=",ordertakeprofit);
         int ticketmodify = OrderModify(ticket, OrderOpenPrice(), SL, TP, 0, Blue);
         if (!ticketmodify) Print("Modify Buy Error ", GetLastError(),"  SL=",SL,"  TP=",TP); 
      }
   }
   if (EmailOn) SendMail(EA_name + " Alert!",Symbol() + " BUY - " + EA_name);
   if (AlertsOn) Alert(Symbol() + EA_name + " BUY");
   if (ArrowsOn)
   {
      ObjectCreate( EA_name + "_Buy_" + Time[0], OBJ_ARROW, 0, TimeCurrent(), Bid);
      ObjectSet( EA_name + "_Buy_" + Time[0], OBJPROP_ARROWCODE, 228);
      ObjectSet( EA_name + "_Buy_" + Time[0], OBJPROP_COLOR, ArrowUP);
   }
}

void Trade_SELL(double lotsize) {

   if (AllowTrading)
   {
      if (!Trade_Check()) return;
      int ticket = OrderSend(Symbol(), OP_SELL, lotsize, Bid, 3, 0, 0, EA_name + EA_vers, MagicNumber, 0, Red);
      if (ticket < 0) { Print("Error opening Order " + GetLastError()); Sleep(30000); }
      if (OrderSelect(ticket, SELECT_BY_TICKET) != False)
      {
         double SL, TP;      
         if (orders < 1) { if (StopLoss > 0 ) SL = OrderOpenPrice() + StopLoss * PipValue; }
         else SL = orderstoploss;
         if (orders < 1) { if (TakeProfit > 0) TP = OrderOpenPrice() - TakeProfit * PipValue; }
         else TP = ordertakeprofit;
         //Print("orderstoploss=",orderstoploss,"  ordertakeprofit=",ordertakeprofit);
         int ticketmodify = OrderModify(ticket, OrderOpenPrice(), SL, TP, 0, Red);
         if (!ticketmodify) Print("Modify Sell Error ", GetLastError(),"  SL=",SL,"  TP=",TP);
      }
   }
   if (EmailOn) SendMail(EA_name + " Alert!",Symbol() + " SELL - " + EA_name);
   if (AlertsOn) Alert(Symbol() + EA_name + " SELL");
   if (ArrowsOn)
   {
      ObjectCreate( EA_name + "_Sell_" + Time[0], OBJ_ARROW, 0, TimeCurrent(), Ask);
      ObjectSet( EA_name + "_Sell_" + Time[0], OBJPROP_ARROWCODE, 230);
      ObjectSet( EA_name + "_Sell_" + Time[0], OBJPROP_COLOR, ArrowDOWN); 
   }
}

void Multi_Orders()
{ 
   if (type == OP_BUY)
   {
      if (openpipsLong > BasketPips) { Close_All(); return(0); }

      switch(orders)
      {
         case 1: if (MaxOrders>1 && lastopenprice - Bid >= step_1 * PipValue) Trade_BUY(Lots*multi_1);
         case 2: if (MaxOrders>2 && lastopenprice - Bid >= step_2 * PipValue) Trade_BUY(Lots*multi_2);
         case 3: if (MaxOrders>3 && lastopenprice - Bid >= step_3 * PipValue) Trade_BUY(Lots*multi_3);
         case 4: if (MaxOrders>4 && lastopenprice - Bid >= step_4 * PipValue) Trade_BUY(Lots*multi_4);
      }
   }
   if (type == OP_SELL)
   {
      if (openpipsShort > BasketPips) { Close_All(); return(0); }

      switch(orders)
      {
         case 1: if (MaxOrders>1 && Ask - lastopenprice >= step_1 * PipValue) Trade_SELL(Lots*multi_1);
         case 2: if (MaxOrders>2 && Ask - lastopenprice >= step_2 * PipValue) Trade_SELL(Lots*multi_2);
         case 3: if (MaxOrders>3 && Ask - lastopenprice >= step_3 * PipValue) Trade_SELL(Lots*multi_3);
         case 4: if (MaxOrders>4 && Ask - lastopenprice >= step_4 * PipValue) Trade_SELL(Lots*multi_4);
      }
   }
}

void Close_All()
{
   for (int pos = OrdersTotal(); pos >= 0; pos--)
   {
      OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      if (OrderType() == OP_BUY ) { OrderClose(OrderTicket(), OrderLots(), Bid, 5, Aqua); Sleep(500); }
      if (OrderType() == OP_SELL) { OrderClose(OrderTicket(), OrderLots(), Ask, 5, Magenta); Sleep(500); }
   }   
}

void Count_Orders()
{
   orders = 0; type = -1;
   double lot_ratio = 1.0;
   lastopenprice= 0.0;
   openpipsLong = 0.0;
   openpipsShort= 0.0;
   int ord_total = OrdersTotal();
   for (int pos = 0; pos < ord_total; pos++)
   {
      OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
         if (OrderLots() > Lots) lot_ratio = OrderLots() / Lots; //multiply pip factor
         if (OrderType() == OP_BUY)
         {
            type = OP_BUY;
            openpipsLong = openpipsLong + (Bid - OrderOpenPrice()) / PipValue * lot_ratio; //sum profit-loss pips
         }
         if (OrderType() == OP_SELL)
         {
            type = OP_SELL;
            openpipsShort = openpipsShort + (OrderOpenPrice() - Ask) / PipValue * lot_ratio;
         }
         orderstoploss = OrderStopLoss();
         ordertakeprofit = OrderTakeProfit();
         lastopenprice = OrderOpenPrice();
         orders++;
      } 
   }
}

bool Trade_Check() {
      for (double cb=0; IsTradeContextBusy() && cb < 100; cb++) Sleep(100); //Wait upto 10 seconds
      if (cb > 0) Print("Trade context was busy ", DoubleToStr(100 * cb / 1000, 2)," seconds");
      if (!IsTradeAllowed()) return(0);
      else return(1);
}

void Display_stats()
{
     msg = "";
     msg = msg
       + "\n " + EA_name + EA_vers
       + "\n ___________________\n"
       + "\n Server Time: " + TimeToStr(TimeCurrent(), TIME_MINUTES)
       + "\n Spread: " + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD) / (PipValue / Point), 1)
       + "\n"
       + "\n Lot Size:  " + DoubleToStr(Lots,2)
       + "\n";
       //if (lastopenprice != 0) msg = msg + "\n lastopenprice= " + DoubleToStr(lastopenprice,Digits);       
       if (openpipsLong != 0) msg = msg + "\n Profit Pips= " + DoubleToStr(openpipsLong,1);
       if (openpipsShort != 0) msg = msg + "\n Profit Pips= " + DoubleToStr(openpipsShort,1);
       
     Comment(msg);
}

